<template>
  <div class="notifications">
    <b-link id="notifications_icon">
      <fa-icon :icon="[iconType, 'bell']" size="lg" />
    </b-link>
    <b-popover target="notifications_icon" triggers="focus" placement="bottom">
      <div v-if="notifications.length > 0">
        <div class="read_all"><b-link @click="markAll">{{ _('Отметить все как прочитанное') }}</b-link></div>
        <div class="notification" v-for="notification in notifications" :key="notification.uid">
          <div :class="['is_active', { active: notification.is_active }]" @click="markNotification(notification)"></div>
          <div class="info" @click="openTask(notification)">
            <div class="type">{{ getNotificationType(notification) }}</div>
            <div class="message">{{ notification.text }}</div>
          </div>
        </div>
      </div>
      <div v-else class="empty">
        <span>Нет уведомлений</span>
        <div class="refresh">
          <b-link @click="update">
            <fa-icon icon="sync" size="lg" :class="{ rotate: updating }" />
          </b-link>
        </div>
      </div>
    </b-popover>
  </div>
</template>

<script>
import { NOTIFICATIONS_LOAD, NOTIFICATIONS_MARK_ALL, NOTIFICATIONS_MARK_ONE,
  TASKS_SELECT_BY_ID, 
CONFIG_SET_ACTIVE_LINK,
PAGE_CURRENT_TASK} from '../data/actions-types'

export default {
  name: 'Notifications',
  mounted () {
    this.$store.dispatch(NOTIFICATIONS_LOAD)
  },
  data () {
    return {
      updating: false
    }
  },
  computed: {
    iconType () {
      return this.notifications.length > 0 ? 'fas' : 'far'
    },
    notifications () {
      return this.$store.getters.unreadNotifications
    }
  },
  methods: {
    update () {
      this.updating = true
      this.$store.dispatch(NOTIFICATIONS_LOAD, true).then(() => {
        setTimeout(() => { this.updating = false }, 500)
      })
    },
    getNotificationType (notification) {
      switch (notification.type) {
        case 1:
          return this._('К заявке был добавлен комментарий:')
        default:
          return this._('В заявке произошло событие:')
      }
    },
    openTask (notification) {
      this.$store.dispatch(TASKS_SELECT_BY_ID, notification.task.uid).then(() => {
        this.$store.dispatch(CONFIG_SET_ACTIVE_LINK, PAGE_CURRENT_TASK).then(() => {
          this.markNotification(notification)
        })
      })
    },
    markAll () {
      this.$store.dispatch(NOTIFICATIONS_MARK_ALL)
    },
    markNotification (notification) {
      notification.is_active = false
      this.$store.dispatch(NOTIFICATIONS_MARK_ONE, notification)
    }
  }
}
</script>

<style lang="scss" scoped>
@keyframes rotate {
  from {
    transform: rotate(0deg)
  }
  to {
    transform: rotate(360deg)
  }
}

.notifications {
  max-height: 400px;
  padding: 0 8px;
}

.read_all {
  padding: 8px 0;
  text-align: center;
}

.empty {
  align-items: center;
  color: #aaa;
  display: flex;
  flex-direction: column;
  font-size: 1.1rem;
  justify-content: center;
  padding: 18px;

  .refresh {
    padding: 18px;
    text-align: center;

    .rotate {
      animation: .5s rotate infinite linear;
    }
  }
}

.notification {
  align-items: center;
  border-bottom: 1px solid #eee;
  display: flex;
  margin: 0;
  padding: 8px 0;

  &:last-of-type {
    border-bottom: none;
  }

  .is_active {
    border-radius: 2em;
    border: 1px solid #eee;
    cursor: pointer;
    flex-shrink: 0;
    height: 12px;
    margin-right: 8px;
    width: 12px;

    &.active {
      background-color: #007bff;
      border-color: #007bff;
    }
  }

  .info {
    cursor: pointer;
    flex-grow: 0;
    min-width: 0px; // i don't know how it works!
  }

  .type {
    color: #aaa;
    font-size: .8rem;
  }

  .message {
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
  }

}
</style>
